/*
 * Copyright (C) 2021 Anton Romanov - All Rights Reserved
 * You may use, distribute and modify this code, please write to: romanov73@gmail.com.
 */

package ru.ulstu.extractor.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import ru.ulstu.extractor.repository.RepositoryRepository;

import static ru.ulstu.extractor.controller.Route.LIST_INDEXED_REPOSITORIES;

@Controller
public class RepositoryController {
    private final RepositoryRepository repositoryRepository;

    public RepositoryController(RepositoryRepository repositoryRepository) {
        this.repositoryRepository = repositoryRepository;
    }

    @GetMapping(LIST_INDEXED_REPOSITORIES)
    public String indexNewRepo(Model model) {
        model.addAttribute("repositories", repositoryRepository.findAll());
        return LIST_INDEXED_REPOSITORIES;
    }
}
