/*
 * Copyright (C) 2021 Anton Romanov - All Rights Reserved
 * You may use, distribute and modify this code, please write to: romanov73@gmail.com.
 */

package ru.ulstu.extractor.heuristic.controller;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.ulstu.extractor.heuristic.model.StructuralUnit;
import ru.ulstu.extractor.heuristic.service.StructuralUnitService;

import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("StructuralUnitController")
public class StructuralUnitController {
    private final StructuralUnitService structuralUnitService;

    public StructuralUnitController(StructuralUnitService structuralUnitService) {
        this.structuralUnitService = structuralUnitService;
    }

    @GetMapping("get-entities")
    public List<StructuralUnit> getEntities(String repositoryUrl) throws IOException {
        return structuralUnitService.getEntities(repositoryUrl);
    }
}
